﻿// bookOfSelectedFolder.jsx 
//DESCRIPTION: Erstellt ein Buch und fügt die Dateien des ausgewählten Ordners ein. 
 
var myPrefix = ''; //'Buch_'; 
var myScanSubfolders = false; // Unterverzeichnisse nach INDD durchsuchen 
 
var myErrors = new Array; 
var myPreset = getPreset(myPrefix); 
var myResult = getFolderAndFiles(myPrefix, myPreset); 
if ( myResult.files.length > 0 ) 
    var myBook = addBook(myResult.folder, myResult.files, myPrefix); 
     
if (myErrors.length > 0) 
    alert('Ошибка!\r' + myErrors.join('\r')); 
 
 
// ----------------------------------------------------------------- 
//                      Vorauswahl (ggf. Pfad des aktiven Dokuments) 
// ----------------------------------------------------------------- 
function getPreset(myPrefix) 
{ 
    if  (parseInt(app.version) <= 4) 
            errorExit('Ошибка\rТребуется Indesign CS3 или более новый.'); 
    var aNote = ''; 
    var aPreset1 = null; 
    // Aktives Dokument vorhanden und gesichert 
    if  (app.documents.length > 0 && app.documents.firstItem().saved == true) 
    { 
        var myDocFP = app.documents.firstItem().filePath; 
        aPreset1 = myDocFP; 
        aPreset2 = myDocFP.parent; 
        // Buchdatei im Pfad des aktiven Dokuments vorhanden 
        if ( File(myDocFP + '/'  + myPrefix + aPreset2.name + '_' + aPreset1.name + '.indb').exists == true ) 
            aNote = '\r(Книга в пути ' + app.documents.firstItem().name + ' уже доступна)'; 
    } 
    return {path:aPreset1, note:aNote}; 
} 
 
// ----------------------------------------------------------------- 
//                      Auswahl Verzeichnis und Datei 
// ----------------------------------------------------------------- 
function getFolderAndFiles(myPrefix, myPreset) 
{ 
    // Dialog zur Auswahl des Verzeichnisses 
    if (myPreset.path == null) myPreset.path = undefined; 
    var theFolder = Folder.selectDialog( "Выберите каталог с документами для своей книги:" + myPreset.note, myPreset.path );  
    if( theFolder == null ) 
        exit(); // Abbruch 
         
    // Indesign-Dateien des Verzeichnisses 
    if (myScanSubfolders == true) 
    { 
        var theFiles = scanSubFolders(theFolder)[0];  
    } 
    else 
        var theFiles = theFolder.getFiles( "*.indd" ); 
    return {folder: theFolder, files: theFiles}; 
} 
 
 
function addBook (myFolder, myFiles, myPrefix) 
{ 
    var myBookFilePath = myFolder + "/"+ myPrefix + myFolder.parent.name + '_' + myFolder.name + ".indb"; 
    var myBookFile = checkExist(File(myBookFilePath), myFolder, myPrefix); 
    //Buch erzeugen 
    aBook = app.books.add( myBookFile ); 
    aBook.automaticPagination = false; // automatische Seitennumerierung abschalten 
    app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract; 
    // Dokumente hinzufügen 
    for ( var i = 0; i < myFiles.length; i++ ) 
    try  
    { 
        aBook.bookContents.add( myFiles[i] ); 
    }  
    catch(e)  
    { 
        myErrors.push( myFiles[i].name + ': Документ не может быть добавлен.') 
    } 
    app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll; 
    if (aBook.bookContents.length > 0) 
        aBook.save( ); 
    else 
    { 
        aBook.close(SaveOptions.NO); 
        myBookFile.remove(); 
    } 
    return aBook; 
} 
 
// ----------------------------------------------------------------- 
//                      Buchdatei bereits vorhanden? 
// ----------------------------------------------------------------- 
function checkExist(aFile, myFolder, myPrefix) 
{ 
     
    while ( aFile.exists == true ) 
    { 
        var newName = prompt ('Ошибка: файл уже существует.', aFile.name.replace(/%20/gi,' ')); 
        if (newName == null) 
            exit(); 
        aFile = File(myFolder + '/' + newName); 
    } 
    return aFile 
} 
 
 
function errorExit( aMessage ) 
{ 
        myErrors.unshift(aMessage) 
        alert( myErrors.join('\r')); 
        exit(); 
} 
 
// ----------------------------------------------------------------- 
//                      Unterordner durchsuchen 
// ----------------------------------------------------------------- 
function scanSubFolders(tFolder)  
{  
   var sFolders = new Array();  
   var inddFiles = new Array();  
   sFolders[0] = tFolder;  
   for (var j = 0; j < sFolders.length; j++) // loop through folders  
   {             
        var procFiles = sFolders[j].getFiles( );  
        for (var k=0;k<procFiles.length;k++) // loop through this folder contents  
        {  
         if (procFiles[k] instanceof File && procFiles[k].name.substr(procFiles[k].name.length-5,5) == '.indd') inddFiles.push(procFiles[k]);  
         else if (procFiles[k] instanceof Folder) sFolders.push(procFiles[k]);  
      }  
   }  
   return [inddFiles,sFolders];  
}  